#pragma once
#pragma warning( disable : 4355)
#include "CommandDefParser.h"
#include <boost/spirit/core.hpp>
#include <boost/bind.hpp>


using namespace boost::spirit;

struct CommandDefinitionParser;
CommandDefinitionParser *g_lpParent=NULL;

struct CommandDefinitionParser : public grammar<CommandDefinitionParser>{
	std::string &CommandIdentifier;	//R}hʖ
	std::vector<BYTE> &ByteStream;
//	std::string &CommandString;	//R}hC
	unsigned int &OutputPort;	//o̓|[gԍ

	CommandDefinitionParser(std::string &ci,unsigned int &uPort,std::vector<BYTE> &bs/*,std::string &cs*/):
		CommandIdentifier(ci),
		ByteStream(bs),
		OutputPort(uPort)//,
//		CommandString(cs)
	{
		g_lpParent=this;
	}

	void AddByte(BYTE byte){
		ByteStream.push_back(byte);
	}

	void SetCommandIdentifier(const char *first,const char *last){
		CommandIdentifier=std::string(first,last);
	}

//	void SetCommandString(const char *first,const char *last){
//		CommandString=std::string(first,last);
//	}

	void SetExecCmd(){
		OutputPort=EXTERNAL_EXEC_COMMAND_PORT;
	}

	void SetOpenCmd(){
		OutputPort=EXTERNAL_OPEN_COMMAND_PORT;
	}

	template<typename S> struct definition{
		uint_parser<BYTE, 16, 2, 2> const byte_parser_hex;	//216iɈv
		uint_parser<BYTE, 2, 8, 8> const byte_parser_binary;	//82iɈv

		rule<S> CommandName,Port,ByteSpecificationHex,ByteSpecificationBinary,Line;
		rule<S> CommandString,ExecCommand,OpenCommand;
		definition(const CommandDefinitionParser& self){
			CommandName=(+(anychar_p-(blank_p|ch_p(':'))))[boost::bind(&CommandDefinitionParser::SetCommandIdentifier,g_lpParent,_1,_2)];
			CommandString=+(anychar_p[boost::bind(&CommandDefinitionParser::AddByte,g_lpParent,_1)]);//(+anychar_p)[boost::bind(&CommandDefinitionParser::SetCommandString,g_lpParent,_1,_2)];
			Port=uint_p[assign(g_lpParent->OutputPort)];
			ExecCommand=as_lower_d["exec"][boost::bind(&CommandDefinitionParser::SetExecCmd,g_lpParent)];
			OpenCommand=as_lower_d["open"][boost::bind(&CommandDefinitionParser::SetOpenCmd,g_lpParent)];
			ByteSpecificationHex=byte_parser_hex[boost::bind(&CommandDefinitionParser::AddByte,g_lpParent,_1)];
			ByteSpecificationBinary=(ch_p('b')|ch_p('B'))>>byte_parser_binary[boost::bind(&CommandDefinitionParser::AddByte,g_lpParent,_1)];
			Line=CommandName>>*blank_p>>ch_p(':')>>*blank_p>>(
				(ExecCommand>>*blank_p>>ch_p(':')>>*blank_p>>CommandString)|
				(OpenCommand>>*blank_p>>ch_p(':')>>*blank_p>>CommandString)|
				(Port>>*blank_p>>ch_p(':')>>*blank_p>>((ByteSpecificationBinary|ByteSpecificationHex)%(+blank_p)))
			)>>*blank_p;
		}
		const rule<S>& start() const { return Line; }
	};
};

//--------------------------------------------------------------------

bool CommandDefinitionParser_Parse(LPCTSTR lpString,std::string &CommandName,unsigned int &uPort,std::vector<BYTE> &ByteArray/*,std::string &CommandString*/)
{
	CommandDefinitionParser Parser(CommandName,uPort,ByteArray/*,CommandString*/);
	parse_info<> Result=boost::spirit::parse(lpString,Parser);

	return Result.full;
}

