#pragma once
#pragma warning( disable : 4355)
#include "SequenceParser.h"
#include <boost/spirit/core.hpp>
#include <boost/bind.hpp>

using namespace boost::spirit;

struct SequenceParser;
SequenceParser *g_lpParent=NULL;

struct SequenceParser : public grammar<SequenceParser>{
	DWORD &dwTimeCode;
	std::string &EventIdentifier;	//Cxgʖ
	DWORD dwHour,dwMin;
	double fSec;

	SequenceParser(DWORD &tc,std::string &ei):
		dwTimeCode(tc),
		EventIdentifier(ei),
		dwHour(0),
		dwMin(0),
		fSec(0)
	{
		g_lpParent=this;
	}

	void SetHour(DWORD dword){dwHour=dword;}
	void SetMinits(DWORD dword){dwMin=dword;}
	void SetSecond(double d){fSec=d;}

	void SetString(const char *first,const char *last){
		EventIdentifier=std::string(first,last);

		//f[^
		dwTimeCode=(unsigned long)(((dwHour*60.0+dwMin)*60.0+fSec)*1000.0);
	}

	template<typename S> struct definition{
		rule<S> TimeCodeA/*ȗȂL@*/,TimeCodeB/*̎wȂL@*/,EventName,Line;
		definition(const SequenceParser& self){
			TimeCodeA=uint_p[boost::bind(&SequenceParser::SetHour,g_lpParent,_1)]>>ch_p(':')>>uint_p[boost::bind(&SequenceParser::SetMinits,g_lpParent,_1)]>>ch_p(':')>>ureal_p[boost::bind(&SequenceParser::SetSecond,g_lpParent,_1)];
			TimeCodeB=uint_p[boost::bind(&SequenceParser::SetMinits,g_lpParent,_1)]>>ch_p(':')>>ureal_p[boost::bind(&SequenceParser::SetSecond,g_lpParent,_1)];
			EventName=(+(anychar_p-blank_p))[boost::bind(&SequenceParser::SetString,g_lpParent,_1,_2)];
			Line=(TimeCodeA|TimeCodeB)>>+blank_p>>EventName;
		}
		const rule<S>& start() const { return Line; }
	};
};

//--------------------------------------------------------------------

bool SequenceParser_GetEvent(LPCTSTR lpString,DWORD &dwTimeCode,std::string &EventName)
{
	SequenceParser Parser(dwTimeCode,EventName);
	parse_info<> Result=boost::spirit::parse(lpString,Parser);

	return Result.full;
}

