#include "common.h"
#include "form.h"
#include "timeobj.h"

LRESULT CFormView::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	//Xe[^Xrbg}bv\pRg[擾
	m_Static_StatusBitmap=GetDlgItem(IDC_STATIC_STATUS);

	//Xe[^Xrbg}bvǂݍ
	m_StatusBitmapArray[STATUS_BITMAP_AUTOMATIC].LoadBitmap(IDB_BITMAP_AUTOMATIC);
	m_StatusBitmapArray[STATUS_BITMAP_MANUAL0].LoadBitmap(IDB_BITMAP_MANUAL0);
	m_StatusBitmapArray[STATUS_BITMAP_MANUAL1].LoadBitmap(IDB_BITMAP_MANUAL1);

	//Xe[^Xݒ
	SetStatus(false);

	//ݎ\pRg[擾
	m_Static_CurrentTime=GetDlgItem(IDC_STATIC_TIMEDATA);
	UpdateCurrentTimeData();

	//G[s̃`FbN{bNX
	m_Check_SkipError=GetDlgItem(IDC_CHECK_SKIP_ERROR);

	//Xgr[
	m_List_Sequence=GetDlgItem(IDC_LIST_COMMAND);
	m_List_Sequence.SetItemCount(0);

	//Jǉ
	CRect rect;
	m_List_Sequence.GetClientRect(rect);
	m_List_Sequence.InsertColumn(0, _T("Time Code"),LVCFMT_LEFT,rect.Width()/5);
	m_List_Sequence.InsertColumn(1, _T("Port"),LVCFMT_LEFT,rect.Width()/5);
	m_List_Sequence.InsertColumn(2, _T("Event"),LVCFMT_LEFT,rect.Width()*3/5);
	m_List_Sequence.SetExtendedListViewStyle(m_List_Sequence.GetExtendedListViewStyle()|LVS_EX_FULLROWSELECT);

	//bZ[W[vɃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddIdleHandler(this);
	//
	Initialize();
	return TRUE;
}

void CFormView::Initialize()
{
	//Xe[^Xݒ
	SetStatus(false);

	//^C}[IuWFNg̏
	CTimeObject::GetInstance().Reset();
	UpdateCurrentTimeData();

	//COM|[g̏
	CCommManager::GetInstance().Init();

	//|[gԍ\
	{
		CString strPortIndicator;
		CCommManager &CommManager=CCommManager::GetInstance();
		for(unsigned int i=0;i<CommManager.GetPortCount();i++){
			CString strTemp;
			strTemp.Format(_T("%s : %d bps / "),CommManager.GetPortName(i),CommManager.GetBaudRate(i));
			strPortIndicator+=strTemp;

			switch(CommManager.GetParityMode(i)){
			case NOPARITY:strPortIndicator+=_T("NoParity");break;		//peB
			case EVENPARITY:strPortIndicator+=_T("Even");break;	//peB
			case MARKPARITY:strPortIndicator+=_T("Mark");break;	//}[NpeB
			case ODDPARITY:strPortIndicator+=_T("Odd");break;		//peB
			case SPACEPARITY:strPortIndicator+=_T("Space");break;	//󔒃peB
			}

			strPortIndicator+=_T(" / ");
			switch(CommManager.GetStopBits(i)){
			case ONESTOPBIT:strPortIndicator+=_T("1bit");break;		//1stopbit
			case ONE5STOPBITS:strPortIndicator+=_T("1.5bits");break;	//1.5stopbits
			case TWOSTOPBITS:strPortIndicator+=_T("2bits");break;		//2stopbits
			}
			strPortIndicator+=_T("\r\n");
		}
		::SetWindowText(GetDlgItem(IDC_EDIT_PORTINFO),strPortIndicator);
	}

	//CxgV[PX̏
	m_EventSequence.Init();
	m_List_Sequence.SetItemCount(m_EventSequence.GetEventCount());
}

void CFormView::StartAnimationTimer()
{
	if(0==m_iAnimationTimerID){
		if(0!=SetTimer(TIMERID_ANIMATION,500)){
			m_iAnimationTimerID=TIMERID_ANIMATION;
		}
	}
}

void CFormView::StopAnimationTimer()
{
	if(0!=m_iAnimationTimerID){
		KillTimer(m_iAnimationTimerID);
		m_iAnimationTimerID=0;
	}
}

void CFormView::OnDestroy()
{
	StopAnimationTimer();
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->RemoveIdleHandler(this);
}

void CFormView::SetStatus(bool bAutomatic)
{
	if(bAutomatic){
		StopAnimationTimer();
		m_Static_StatusBitmap.SetBitmap(m_StatusBitmapArray[STATUS_BITMAP_AUTOMATIC]);
	}
	else{
		CTimeObject::GetInstance().Halt();
		StartAnimationTimer();
		m_Static_StatusBitmap.SetBitmap(m_StatusBitmapArray[STATUS_BITMAP_MANUAL0]);
	}
}

void CFormView::OnTimer(UINT ID,TIMERPROC)
{
	if(ID!=TIMERID_ANIMATION||0==m_iAnimationTimerID)return;

	m_iCurrentBitmapIndex++;
	m_iCurrentBitmapIndex%=STATUS_BITMAP_MAX_COUNT-1;

	m_Static_StatusBitmap.SetBitmap(m_StatusBitmapArray[STATUS_BITMAP_MANUAL0+m_iCurrentBitmapIndex]);
}

//OnIdleŌĂ΂BCxg̑M^C~O`FbNB
void CFormView::ActMessage()
{
	//Cxg̃`FbN
	static CTimeObject &TimeObject=CTimeObject::GetInstance();
	if(TimeObject.IsHalted())return;

	switch(m_EventSequence.OnTimerCall()){
	case EVENT_NOT_EXECUTED:
		//Nothing to do
		break;
	case EVENT_ERROR:	//CxgsɎs
		m_List_Sequence.Invalidate();
		if(m_Check_SkipError.GetCheck()){
			m_EventSequence.ForceNextEvent();	//΂Ď
		}else{		//G[𖳎Ȃ
			SetStatus(false);	//}jA[hɈڍs
		}
		break;
	case EVENT_FINISHED:
		m_List_Sequence.Invalidate();
		SetStatus(false);	//CxgsɎs}jA[hɈڍs

		//FALLTHROUGH
	case EVENT_EXECUTED:
		m_List_Sequence.SetItemState(-1,0,LVIS_SELECTED);
		m_List_Sequence.SetItemState(m_EventSequence.GetLastSequence(),LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
		m_List_Sequence.EnsureVisible(m_EventSequence.GetLastSequence(),false);
		m_List_Sequence.Invalidate();
		break;
	}
	UpdateCurrentTimeData();
	Sleep(1);	//Ƃx
}

//zXgr[
LRESULT CFormView::OnGetDispInfo(LPNMHDR pnmh)
{
	LV_DISPINFO* pstLVDInfo=(LV_DISPINFO*)pnmh;

	const int Index=pstLVDInfo->item.iItem;
	if(Index<0||Index>=m_EventSequence.GetEventCount())return FALSE;
	if(!(pstLVDInfo->item.mask & LVIF_TEXT))return FALSE;

	CEventItem* lpEvent=m_EventSequence.GetEventSequence(Index);
	if(!lpEvent)return FALSE;

	switch(pstLVDInfo->item.iSubItem){
	case 0:	//^CR[h
		{
			DWORD dwTime=lpEvent->GetTimeCode();
			double fSec=(dwTime%(60*1000))/1000.0;
			dwTime-=dwTime%(60*1000);
			dwTime/=60*1000;
			DWORD dwMin=dwTime%60;
			dwTime-=dwMin;
			dwTime/=60;
			DWORD dwHour=dwTime;
			_sntprintf(pstLVDInfo->item.pszText,pstLVDInfo->item.cchTextMax, _T("%d:%d:%.3f"),dwHour,dwMin,fSec);
		}
		return TRUE;
	case 1:	//|[g
		_tcsncpy(pstLVDInfo->item.pszText, lpEvent->GetPortName(),pstLVDInfo->item.cchTextMax);
		return TRUE;
	case 2:	//Cxg
		_tcsncpy(pstLVDInfo->item.pszText, lpEvent->GetEventName(),pstLVDInfo->item.cchTextMax);
		return TRUE;
	}
	return FALSE;
}

//JX^h[
LRESULT CFormView::OnCustomDraw(LPNMHDR pnmh)
{
	if(pnmh->hwndFrom!=m_List_Sequence)return 0;
	LPNMLVCUSTOMDRAW lpCustomDraw=(LPNMLVCUSTOMDRAW)pnmh;
	if(lpCustomDraw->nmcd.dwDrawStage!=CDDS_ITEMPREPAINT){
		return CDRF_NOTIFYITEMDRAW;
	}

	const int Index=lpCustomDraw->nmcd.dwItemSpec;
	if(Index<0||Index>=m_EventSequence.GetEventCount())return FALSE;
	CEventItem* lpEvent=m_EventSequence.GetEventSequence(Index);
	if(!lpEvent)return FALSE;

	COLORREF Text=0,BG=0;
	switch(lpEvent->GetStatus()){
	case EVENTITEM_STANDBY:
		BG=RGB(255,255,255);
		Text=RGB(0,0,0);
		break;
	case EVENTITEM_DONE:
		BG=RGB(204,204,255);
		Text=RGB(51,51,51);
		break;
	case EVENTITEM_FAILED:
		BG=RGB(255,153,153);
		Text=RGB(0,0,102);
		break;
	}
	lpCustomDraw->clrTextBk=BG;
	lpCustomDraw->clrText=Text;
	return 0;
}


//CxgV[PXt@C̓ǂݍ
void CFormView::OnLoad(UINT,int,HWND)
{
	Initialize();
	CFileDialog dlg(TRUE, _T("txt"), NULL, OFN_HIDEREADONLY | OFN_NOCHANGEDIR,_T("Sequence File(*.txt)\0*.txt\0\0"));
	if(dlg.DoModal()!=IDOK)return;

	m_EventSequence.ReadFromFile(dlg.m_szFileName);
	m_List_Sequence.SetItemCount(m_EventSequence.GetEventCount());
}

//I
void CFormView::OnExit(UINT,int,HWND)
{
	::PostMessage(GetParent(),WM_CLOSE,NULL,NULL);
}

//[hŃX^[g
void CFormView::OnAutomatic(UINT,int,HWND)
{
	SetStatus(true);
	CTimeObject::GetInstance().Resume();
}

//}jA[hɈڍs
void CFormView::OnManual(UINT,int,HWND)
{
	SetStatus(false);
	CTimeObject::GetInstance().Halt();
}

//ݎ̕\XV
void CFormView::UpdateCurrentTimeData()
{
	DWORD dwTime=CTimeObject::GetInstance().GetTime();
	double fSec=(dwTime%(60*1000))/1000.0;
	dwTime-=dwTime%(60*1000);
	dwTime/=60*1000;
	DWORD dwMin=dwTime%60;
	dwTime-=dwMin;
	dwTime/=60;
	DWORD dwHour=dwTime;

	TCHAR Buffer[256]={0};
	_sntprintf(Buffer,255, _T("CurrentTime=%d:%d:%.3f"),dwHour,dwMin,fSec);
	m_Static_CurrentTime.SetWindowText(Buffer);
}

//蓮s
void CFormView::OnManualExecute(UINT,int,HWND)
{
	ManualExecute();
}

//V[PXԂZbg
void CFormView::OnResetSequence(UINT,int,HWND)
{
	SetStatus(false);
	CTimeObject::GetInstance().Reset();
	m_EventSequence.Reset();
	m_List_Sequence.SetItemState(-1,0,LVIS_SELECTED);
	m_List_Sequence.SetItemState(m_EventSequence.GetLastSequence(),LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
	m_List_Sequence.EnsureVisible(m_EventSequence.GetLastSequence(),false);
	m_List_Sequence.Invalidate();

	UpdateCurrentTimeData();
}

//蓮s
LRESULT CFormView::OnManualExecute_List(LPNMHDR pnmh)
{
	//Xgr[̒ʒm
	if(pnmh->hwndFrom==m_List_Sequence){
		ManualExecute();
	}
	return 0;
}

bool CFormView::ManualExecute()
{
	if(GetStatus()){
		SetStatus(false);
		CTimeObject::GetInstance().Halt();
		//[ĥƂɂ̓}jA[hɗ
	}

	//IꂽACe擾
	int iItem=m_List_Sequence.GetNextItem(-1,LVNI_ALL|LVNI_SELECTED);
	if(-1==iItem||iItem>=m_EventSequence.GetEventCount())return false;

	//蓮s
	bool bRet=m_EventSequence.ManualExecute(iItem);

	m_List_Sequence.Invalidate();
	UpdateCurrentTimeData();
	return bRet;
}


//`t@CR}hXg쐬
void CFormView::OnCommandList(UINT,int,HWND)
{
	m_EventSequence.MakeFromCommandList();
	m_List_Sequence.SetItemCount(m_EventSequence.GetEventCount());
}

void CFormView::OnOK(UINT,int,HWND)	//܂OnEnterKey()
{
	if(GetKeyState(VK_SHIFT)<0){	//SHIFT+EnterAutomatic
		SetStatus(true);
		CTimeObject::GetInstance().Resume();
	}
	else ManualExecute();
}
