#include "common.h"
#include "commandlist.h"
#include "../util.h"
#include "../CommandDefParser/CommandDefParser.h"
#include "../resource.h"

CCommandList::CCommandList()
{
}

CCommandList::~CCommandList()
{
}

bool CCommandList::AddCommandItem(const std::string &CommandName,unsigned int uPort,std::vector<BYTE>& ByteStream)
{
	Map_CommandName.insert(std::pair<std::string,BYTE_STREAM>(CommandName,BYTE_STREAM(uPort,ByteStream)));
	return true;
}

bool CCommandList::GetByteStream(const std::string& CommandName,unsigned int& uPort,LPCBYTE &lpByte,DWORD &dwSize)
{
	std::hash_map<std::string,BYTE_STREAM >::iterator ite;
	ite=Map_CommandName.find(CommandName);
	if(ite==Map_CommandName.end())return false;

	//̂Ń|[gԍƃoCgԂ
	uPort=(*ite).second.first;
	lpByte=&(*ite).second.second[0];
	dwSize=(*ite).second.second.size();
	return true;
}

bool CCommandList::ReadFromFile()
{
	Clear();
	//R}h`t@C̃pX擾
	TCHAR FileName[_MAX_PATH+1]={0};
	GetModuleFileName(NULL,FileName,_MAX_PATH);
	PathRemoveFileSpec(FileName);
	PathAppend(FileName,_T("Command.def"));

	//t@Cobt@
	std::vector<BYTE> Buffer;

	//t@Cǂݍ
	HANDLE hFile=CreateFile(FileName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(INVALID_HANDLE_VALUE==hFile){
		UtilErrorMessage(NULL,CString(MAKEINTRESOURCE(IDS_ERROR_READ_COMMANDFILE)));
		return false;
	}

	//4GB傫ȃt@CTCY͎擾łȂAIɂ͂̂悤ȑ傫ȃt@C͈Ȃ
	DWORD dwSize=GetFileSize(hFile,NULL);

	if(dwSize<=0){
		CloseHandle(hFile);
		UtilErrorMessage(NULL,CString(MAKEINTRESOURCE(IDS_ERROR_READ_COMMANDFILE)));
		return false;
	}
	dwSize++;	//+1 is for '\0'
	Buffer.resize(dwSize);
	DWORD dwRead=0;
	BOOL Ret=ReadFile(hFile,&Buffer[0],dwSize-1,&dwRead,NULL);
	CloseHandle(hFile);
	if(!Ret||dwRead!=dwSize-1){
		UtilErrorMessage(NULL,CString(MAKEINTRESOURCE(IDS_ERROR_READ_COMMANDFILE)));
		return false;
	}

	//I[
	Buffer[dwSize-1]='\0';

	//ʒusPʂŃR}h`t@C
	DWORD dwIndex=0;
	CString Line;
	for(;dwIndex<dwSize;dwIndex++){
		TCHAR c=Buffer[dwIndex];
		if(c==_T('\n')||c==_T('\r')||c==_T('\0')){
			Line.Remove(_T('\n'));
			Line.Remove(_T('\r'));

			if(Line.IsEmpty())continue;

			TRACE("%s\n",Line);

			std::string CommandName;
			std::vector<BYTE> ByteStream;
			unsigned int uPort;
			if(!CommandDefinitionParser_Parse(Line,CommandName,uPort,ByteStream)){
				//p[XɎs
				UtilErrorMessage(NULL,CString(MAKEINTRESOURCE(IDS_ERROR_PARSE_COMMANDFILE)));
				return false;
			}
			Line.Empty();
			//R}h`ǉ
			AddCommandItem(CommandName,uPort,ByteStream);
		}
		else{
			Line+=c;
		}
	}

	return true;
}

void CCommandList::GetIterator(COMMAND_MAP_ITERATOR &begin,COMMAND_MAP_ITERATOR &end)
{
	begin=Map_CommandName.begin();
	end=Map_CommandName.end();
}

void CCommandList::Clear()
{
	Map_CommandName.clear();
}
