#pragma once
#include "../common.h"
#include "eventitem.h"
#include "commandlist.h"

enum EVENT_STATUS{
	EVENT_NOT_EXECUTED,
	EVENT_EXECUTED,
	EVENT_ERROR,
	EVENT_FINISHED
};

class CEventSequence{
protected:
	std::vector<CEventItem*> m_EventArray;
	CCommandList m_CommandList;

	virtual void SortByTime();
	int m_iLastSequenceIndex;
	void Clear();
public:
	CEventSequence();
	virtual ~CEventSequence();
	virtual bool ReadFromFile(LPCTSTR);
	virtual bool Init();
	virtual int GetEventCount(){return m_EventArray.size();}

	virtual CEventItem* GetEventSequence(int);
	virtual EVENT_STATUS OnTimerCall();
	virtual bool ManualExecute(int);

	virtual int GetLastSequence(){return m_iLastSequenceIndex;}

	virtual int ForceNextEvent(){m_iLastSequenceIndex++;return m_iLastSequenceIndex;}

	virtual void Reset();

	virtual bool MakeFromCommandList();	//R}hXgV[PX쐬
};

