#pragma once
#include "common.h"

//ꎞ~@\擾NX;0IW

class CTimeObject{
protected:
	DWORD dwOffset;
	DWORD dwHaltBegin;
	CTimeObject():dwOffset(timeGetTime()),dwHaltBegin(timeGetTime()){}
public:
	virtual ~CTimeObject(){}

	static CTimeObject& GetInstance(){
		static CTimeObject Singleton;
		return Singleton;
	}

	DWORD GetTime(){
		if(0!=dwHaltBegin)return dwHaltBegin-dwOffset;
		return timeGetTime()-dwOffset;
	}
	void Halt(){
		if(0!=dwHaltBegin)return;
		dwHaltBegin=timeGetTime();
	}
	void Resume(){
		if(0==dwHaltBegin)return;
		dwOffset+=timeGetTime()-dwHaltBegin;
		dwHaltBegin=0;
	}
	void Toggle(){
		if(IsHalted())Resume();
		else Halt();
	}
	inline bool IsHalted(){return 0!=dwHaltBegin;}

	void Reset(DWORD dwTime=0){	//̎ԃJEgw肵ԂɃZbg
		const DWORD dwNow=timeGetTime();
		dwHaltBegin=dwNow;
		dwOffset=dwNow-dwTime;
	}
};

